--control.lua

require 'stdlib/table'
require 'stdlib/log/logger'
require 'serpent'
require 'core/command'

--CONFIG MECHANICS
Config = {}
ConfigName = {}
ConfigSettingsList = {}
LastLogfileName = "default"

function addConfigSetting(alias, setting_name)
   Config[setting_name] = nil
   ConfigName[alias] = setting_name
   ConfigSettingsList[#ConfigSettingsList + 1] = setting_name
end

function loadConfigSetting(setting_name)
   Config[setting_name]=settings.global[setting_name].value
end

function getConfigSetting(alias)
   return Config[ConfigName[alias]]
end

--addConfigSetting("Admins","alone-together-admins")

for alias,realsettingname in pairs(ConfigName) do
   loadConfigSetting(realsettingname)
end

script.on_init(generatePublicUniverse)

script.on_event({defines.events.on_runtime_mod_setting_changed},
   function (e)
      for _,v in pairs(ConfigSettingsList) do
         if e.setting == v then
            loadConfigSetting(e.setting)
            break
         end
      end
      
   end
)

load_command_aliases()

commands.add_command("universe-spawn", "help", process_command)
commands.add_command("universe-set-home", "help", process_command)
commands.add_command("universe-switch", "help", process_command)
commands.add_command("universe-home", "help", process_command)
commands.add_command("universe-accept", "help", process_command)
commands.add_command("universe-reject", "help", process_command)

-- team
commands.add_command("universe-level", "help", process_command)
commands.add_command("universe-reset", "help", process_command)
commands.add_command("universe-lock", "help", process_command)
commands.add_command("universe-unlock", "help", process_command)
commands.add_command("universe-invite", "help", process_command)
commands.add_command("universe-info", "help", process_command)
commands.add_command("universe-leave", "help", process_command)
commands.add_command("universe-make-leader", "help", process_command)
commands.add_command("universe-coop", "help", process_command)
commands.add_command("universe-expel", "help", process_command)

--team leader
commands.add_command("universe-settings", "help", process_command)
commands.add_command("universe-kick", "help", process_command)

--admin
commands.add_command("universe-delete", "help", process_command)
commands.add_command("universe-purge", "help", process_command)
commands.add_command("universe-top-ten", "help", process_command)
commands.add_command("universe-unregister", "help", process_command)
commands.add_command("universe-team-remove", "help", process_command)
commands.add_command("universe-team-add", "help", process_command)